"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const next_1 = require("../next");
const or_1 = require("../or");
const oauth_1 = require("./oauth");
const resilient_1 = require("../resilient");
const cache_1 = require("./oauth/secretsProvider/cache");
const refreshToken_1 = require("./oauth/tokenProvider/refreshToken");
const setAuthorization_1 = require("./oauth/tokenProvider/setAuthorization");
const passcode_1 = require("./passcode");
const technicalJWT_1 = require("./technicalJWT");
const options_1 = require("../options");
const constants_1 = require("../../../constants");
const core_1 = require("../../../config/core");
const succeed_1 = require("../succeed");
exports.create = process.env.SUPPORT === "true"
    ? technicalJWT_1.create
    : () => (0, next_1.create)("commands.handler.authentication", (0, resilient_1.create)((0, next_1.create)("commands.handler.authentication$oauth", (0, cache_1.create)(), (0, refreshToken_1.create)())), (0, options_1.create)(constants_1.OPTION_CLIENT_ID), (0, options_1.create)(constants_1.OPTION_CLIENT_SECRET), (0, options_1.create)(constants_1.OPTION_ACCESS_TOKEN), (0, options_1.create)(constants_1.OPTION_REFRESH_TOKEN), (0, options_1.create)(constants_1.OPTION_CODE), (0, options_1.create)(constants_1.OPTION_TOKEN_URL), (0, options_1.create)(constants_1.OPTION_AUTHORIZATION_URL), (0, core_1.getAuthenticationMethods)().includes(constants_1.AuthenticationMethod.passcode)
        ? (0, options_1.create)(constants_1.OPTION_PASSCODE)
        : (0, succeed_1.create)(), (0, options_1.create)(constants_1.OPTION_SECRETS_FILE), (0, or_1.create)("commands.handler.authentication$handler", (0, setAuthorization_1.create)(), (0, passcode_1.create)(), (0, oauth_1.create)()));
