"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const logger_1 = require("../../../../../logger");
const SecretsStorageSingleton_1 = require("../../../../../cache/secrets/SecretsStorageSingleton");
const create = () => async () => async () => {
    const { error, info } = (0, logger_1.get)("commands.handler.authentication.oauth.secretsProvider.cache");
    info("reading secrets from cache");
    try {
        // verify whether secret is available by retrieving default secret for current host
        await SecretsStorageSingleton_1.SecretsStorageSingleton.SINGLETON.getDefaultSecret();
    }
    catch (err) {
        error("failed to read secrets from cache", err);
        throw err;
    }
};
exports.create = create;
