"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const fs_extra_1 = require("fs-extra");
const next_1 = require("../../../next");
const constants_1 = require("../../../../../constants");
const logger_1 = require("../../../../../logger");
const options_1 = require("../../../../../utils/options");
const options_2 = require("../../../options");
const SecretsStorageSingleton_1 = require("../../../../../cache/secrets/SecretsStorageSingleton");
const handler = async () => async () => {
    const { error, debug, info } = (0, logger_1.get)("commands.handler.authentication.oauth.secretsProvider.file");
    info("reading secrets from file");
    try {
        const secretsFile = (0, options_1.getOptionValueFromConfig)(constants_1.OPTION_SECRETS_FILE);
        await SecretsStorageSingleton_1.SecretsStorageSingleton.SINGLETON.storeSecret(JSON.parse(await (0, fs_extra_1.readFile)(secretsFile, "utf8")));
        debug("secrets found from file");
    }
    catch (err) {
        error("failed to read secrets from file", err);
        throw err;
    }
};
const create = () => (0, next_1.create)("commands.handler.authentication.oauth.secretsProvider.file", (0, options_2.create)([constants_1.OPTION_SECRETS_FILE]), handler);
exports.create = create;
