import { Option } from "./types";
export declare const VERSION: string;
export type CoreConfiguration = {
    getName: () => string;
    getPackageName: () => string;
    getDescription: () => string;
    getDiscoveryPaths: () => Array<string>;
    getSapHelp: () => string;
    getAuthenticationMethods: () => Array<AuthenticationMethod>;
    getVersion: () => string;
    isDeprecated: () => boolean;
    getDeprecationMessage: () => string;
    getGenericOptionsHelp: () => string;
};
export declare const DISCOVERY_DOCUMENT_PREFIX = "discovery-";
export declare enum AuthenticationMethod {
    oauth = "oauth",
    passcode = "passcode"
}
export declare const ROOT_COMMAND: any;
export declare const CLI_NAME = "cli-name";
export declare const CLI_PACKAGE_NAME = "cli-package-name";
export declare const CLI_DESCRIPTION = "cli-description";
export declare const CLI_DISCOVERY_PATHS = "cli-discovery-paths";
export declare const CLI_SAP_HELP = "cli-sap-help";
export declare const CLI_VERSION = "cli-version";
export declare const CLI_DEPRECATED = "cli-deprecated";
export declare const CLI_DEPRECATION_MESSAGE = "cli-deprecation-message";
export declare const CLI_SUPPORTED_AUTHENTICATION_METHODS = "cli-supported-authentication-methods";
export declare const CLI_GENERIC_OPTIONS_HELP = "cli-generic-options-help";
export declare const SEGMENTS_TO_REMOVE_FOR_PASSCODE_AUTH: string[];
export declare const DISCOVERY_METADATA_PATH = "discovery-metadata.json";
export declare const X_CSRF_TOKEN = "x-csrf-token";
export declare const X_DSP_API_DEPRECATED_PROPERTIES = "x-dsp-api-deprecated-properties";
export declare const X_OUTPUT_FILE_NAME = "x-sap-datasphere-cli-file-name";
export declare const PATH_TO_SUCCESS_HTML: string;
export declare const PATH_TO_ERROR_HTML: string;
export declare const CACHE_SECRETS_FILE = "secrets.json";
export declare const OPTION_VERSION: Option;
export declare const OPTION_HELP: Option;
export declare const OPTION_HOST: Option;
export declare const OPTION_LOGIN_ID: Option;
export declare const OPTION_OUTPUT: Option;
export declare const OPTION_NO_PRETTY: Option;
export declare const OPTION_VERBOSE: Option;
export declare const OPTION_FORCE: Option;
export declare const OPTION_CLIENT_ID: Option;
export declare const OPTION_CLIENT_SECRET: Option;
export declare const OPTION_AUTHORIZATION_URL: Option;
export declare const OPTION_TOKEN_URL: Option;
export declare const OPTION_ACCESS_TOKEN: Option;
export declare const OPTION_REFRESH_TOKEN: Option;
export declare const OPTION_EXPIRES_IN: Option;
export declare const OPTION_SECRETS_FILE: Option;
export declare const OPTION_CODE: Option;
export declare const OPTION_PASSCODE: Option;
export declare const CONFIG_PASSCODE_FUNCTION = "passcodeFunction";
export declare const OPTION_OPTIONS_FILE: Option;
export declare const OPTION_FILE_PATH: Option;
export declare const OPTION_INPUT: Option;
export declare const OPTION_BROWSER: Option;
